/* This is the code for testing the Arduino keyboard, ELECTRONOOBS 21/08/2019
 *  Tutorial: https://electronoobs.com/eng_arduino_tut103.php
 *  Schematic: https://electronoobs.com/eng_arduino_tut103_sch2.php
 *  Code: https://electronoobs.com/eng_arduino_tut103_code3.php  
 *  YouTube channel: https://www.youtube.com/channel/UCjiVhIvGmRZixSzupD0sS9Q
 * 
 *  Connect Rx and Tx to any other microcontroller and use serial at 115200 bauds.*/
 
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x3f,20,4);   //sometimes the LCD adress 0x3f and sometimes is 0x27. Try both. 


char Str[16] = {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '}; 
char Str2[16] = {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '}; 
String text_to_print = " ";
int i = 0;

void setup() {
  lcd.init();                 //Init the LCD
  lcd.backlight();            //Activate backlight 
  Serial.begin(115200);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Push any key!");
}

void loop() {
  if(Serial.available() > 0)
  {
    char RECEIVED = Serial.read();

    if(RECEIVED == '{')
    {
      lcd.clear();
      lcd.setCursor(0,0);
      lcd.print("SENT");
      delay(1000);
      i = 0;
      Str[0] = ' '; 
      Str[1] = ' '; 
      Str[2] = ' '; 
      Str[3] = ' '; 
      Str[4] = ' '; 
      Str[5] = ' '; 
      Str[6] = ' '; 
      Str[7] = ' '; 
      Str[8] = ' '; 
      Str[9] = ' '; 
      Str[10] = ' '; 
      Str[11] = ' '; 
      Str[12] = ' '; 
      Str[13] = ' '; 
      Str[14] = ' '; 
      Str[15] = ' '; 
      
      Str2[0] = ' '; 
      Str2[1] = ' '; 
      Str2[2] = ' '; 
      Str2[3] = ' '; 
      Str2[4] = ' '; 
      Str2[5] = ' '; 
      Str2[6] = ' '; 
      Str2[7] = ' '; 
      Str2[8] = ' '; 
      Str2[9] = ' '; 
      Str2[10] = ' '; 
      Str2[11] = ' '; 
      Str2[12] = ' '; 
      Str2[13] = ' '; 
      Str2[14] = ' '; 
      Str2[15] = ' ';
    }

    else
    {
      if(i < 15)
      {
         Str[i] = RECEIVED;
      }
      else
      {
        Str2[i-15] = RECEIVED;
      }
      
      i = i+1;
      lcd.clear();
      lcd.setCursor(0,0);
      lcd.print(Str[0]);
      lcd.print(Str[1]);
      lcd.print(Str[2]);
      lcd.print(Str[3]);
      lcd.print(Str[4]);
      lcd.print(Str[5]);
      lcd.print(Str[6]);
      lcd.print(Str[7]);
      lcd.print(Str[8]);
      lcd.print(Str[9]);
      lcd.print(Str[10]);
      lcd.print(Str[11]);
      lcd.print(Str[12]);
      lcd.print(Str[13]);
      lcd.print(Str[14]);
      lcd.print(Str[15]);
  
      lcd.setCursor(0,1);
      lcd.print(Str2[0]);
      lcd.print(Str2[1]);
      lcd.print(Str2[2]);
      lcd.print(Str2[3]);
      lcd.print(Str2[4]);
      lcd.print(Str2[5]);
      lcd.print(Str2[6]);
      lcd.print(Str2[7]);
      lcd.print(Str2[8]);
      lcd.print(Str2[9]);
      lcd.print(Str2[10]);
      lcd.print(Str2[11]);
      lcd.print(Str2[12]);
      lcd.print(Str2[13]);
      lcd.print(Str2[14]);
      lcd.print(Str2[15]);
    }
  }
}
